CraftList2 = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1")
local L = AceLibrary("AceLocale-2.2"):new("CraftList2")
local G = AceLibrary("Gratuity-2.0")
local BTS= AceLibrary("Babble-Tradeskill-2.2")
local waterfall = AceLibrary("Waterfall-1.0")

local prefix_ench = "!enchant"
local prefix_gem = "!gem"
local prefix_other = "!craft"
local prefix_answers = "cL2>"

local mem_search={}
local mem_next={}

function CraftList2:OnInitialize()
	CraftList2:RegisterDB("CraftList2DB")
	CraftList2:RegisterDefaults("realm", {
		data = {},
		ignored_crafts={},
		maxresults=10,
		showrequests=true,
		showanswers=true,
		trigger_ench=true,
		trigger_gem=true,
		trigger_other=true,
		}
	)  
end
function CraftList2:BuildOpts()

	self.cl2opt={}
	self.cl2opt = { 
		type="group",
		name="CraftList2",
		desc="CraftList2",
		args = {
			inc= {
				type="toggle",
				name=L["Show incoming requests"],
				desc=L["Show incoming requests"],
				get=function() return self.db.realm.showrequests end,
				set=function(v) self.db.realm.showrequests = v end,
				order=2,
			},
			out= {
				type="toggle",
				name=L["Show your replies"],
				desc=L["Show your replies"],
				get=function() return self.db.realm.showanswers end,
				set=function(v) self.db.realm.showanswers = v end,
				order=3,
			},
			maxresults= {
				type="range",
				name=L["Maximum results"],
				desc=L["Maximum of results sent to someone (0=no limit)"],
				get=function() return self.db.realm.maxresults end,
				set=function(v) self.db.realm.maxresults = v end,
				min=0,
				max=100,
				step=1,
				order=1,
			},
			reset={
				type="execute",
				name=L["Reset all data"],
				desc=L["Reset all stored data for all characters"],
				order=4,
				confirm=true,
				func=function() 
					self.db.realm.data={}
					self.db.realm.ignored_crafts={}
					if waterfall:IsRegistered('CraftList2') then waterfall:UnRegister('CraftList2') end
					waterfall:Register('CraftList2', 
					'aceOptions',self.cl2opt,
					'title','CraftList2')
					if waterfall:IsOpen('CraftList2') then waterfall:Refresh('CraftList2') end
					return
					end,
			},
			triggers={
				type="group",
				name=L["Triggers"],
				desc=L["Triggers"],
				order=5,
				args={ 
					ench={
						type="toggle",
						name=prefix_ench,
						desc=prefix_ench,
						get=function()
							return self.db.realm.trigger_ench
							end,
						set=function(v)
							self.db.realm.trigger_ench = not self.db.realm.trigger_ench 
							end,
					},
					gem={
						type="toggle",
						name=prefix_gem,
						desc=prefix_gem,
						get=function()
							return self.db.realm.trigger_gem
							end,
						set=function(v)
							self.db.realm.trigger_gem = not self.db.realm.trigger_gem 
							end,
					},
					other={
						type="toggle",
						name=prefix_other,
						desc=prefix_other,
						get=function()
							return self.db.realm.trigger_other
							end,
						set=function(v)
							self.db.realm.trigger_other = not self.db.realm.trigger_other 
							end,
					},
				
				},
			},
			active= {
				type="group",
				name=L["Active Professions"],
				desc=L["Check here what professions you want to track"],
				args = {},
				order=6,
			},
			ignored = {
				type="group",
				name=L["Active Crafts"],
				desc=L["Uncheck here crafts you want to be ignored"],
				args = {},
				order=7,
			}
		}
	}
	
	local j=1
	local k=1
	for character, tradeskill in pairs(self.db.realm.data) do
		self.cl2opt.args.ignored.args[j] = 
			{
				type="group",
				name=character,
				desc=character,
				args={},
			}
		local l=1
		for ts,tsinfo in pairs(tradeskill) do
			self.cl2opt.args.active.args[k] = 
			{
				type="toggle",
				name=character.." - "..ts,
				desc=character.." - "..ts,
				get=function() 
					if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
					return not self.db.realm.ignored_crafts[character][ts] 
					end,
				set=function(v) 
					if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
					self.db.realm.ignored_crafts[character][ts] = not self.db.realm.ignored_crafts[character][ts] 
					end,
			}
			k=k+1
			self.cl2opt.args.ignored.args[j].args[l] = 
				{
					type="group",
					name=ts,
					desc=ts,
					args={},
					disabled=function() 
					if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
					return self.db.realm.ignored_crafts[character][ts] 
					end,
				}
				
			self.cl2opt.args.ignored.args[j].args[l].args[1] = 
			{
				type="execute",
				name="Check all",
				desc="Check all",
				order=1,
				func=function() 
					for nb,info in pairs(tsinfo) do
						info.ignored=false
					end
				end,
			}
			self.cl2opt.args.ignored.args[j].args[l].args[2] = 
			{
				type="execute",
				name="Uncheck all",
				desc="Uncheck all",
				order=2,
				func=function() 
					for nb,info in pairs(tsinfo) do
						info.ignored=true
					end
				end,
			} 
			local m=3
			for nb,info in pairs(tsinfo) do
				local desc = info["desc"]
				if not desc  and info.itemlink then 
					desc=""
					G:SetHyperlink(info["itemlink"])
					for i=1,G:NumLines() do
						desc=desc.."\n"..G:GetLine(i)
					end
				end
				self.cl2opt.args.ignored.args[j].args[l].args[m] = 
				{
					type="toggle",
					name=info["name"],
					desc= desc,
					order=3,
					get=function()
						return not self.db.realm.data[character][ts][nb]["ignored"] end,
					set=function(v)
						info.ignored = not info.ignored
						end,
				}
				m=m+1
			end
			l=l+1
		end
		j=j+1
	end
	

end

function CraftList2:OnEnable()
	self:Hook("ChatFrame_MessageEventHandler", "WhisperHandler", true)
	self:RegisterEvent("CHAT_MSG_WHISPER")
	self:RegisterEvent("CRAFT_SHOW")
	self:RegisterEvent("TRADE_SKILL_SHOW")
	self:Hook("ChatFrame_OnEvent", "HandleAFKDND", true)
	self.filterafkdnd={}
	
	self:RegisterChatCommand('/clist', '/craftlist', '/clist2', '/craftlist2', {
		type = 'execute',
		func = function()
			self:BuildOpts()
			if waterfall:IsRegistered('CraftList2') then waterfall:UnRegister('CraftList2') end
			waterfall:Register('CraftList2', 
				'aceOptions',self.cl2opt,
				'title','CraftList2'
			)
			waterfall:Open('CraftList2')
		end
	})
end

function CraftList2:OnDisable()
	self:UnhookAll()
	self:UnregisterEvent("CHAT_MSG_WHISPER")
	self:UnregisterEvent("CRAFT_SHOW")
	self:UnregisterEvent("TRADE_SKILL_UPDATE")
end

function CraftList2:CRAFT_SHOW()
	local craftname= CraftFrameTitleText:GetText()
	self:ScanCraft(craftname)
end

function CraftList2:TRADE_SKILL_SHOW()
	local tsname= TradeSkillFrameTitleText:GetText()
	self:ScanTS(tsname)
end

function CraftList2:HandleAFKDND()
	local author = arg2
	if ( event == "CHAT_MSG_AFK" or event == "CHAT_MSG_DND") then
		if self.filterafkdnd[author] then return end
	end
	return self.hooks["ChatFrame_OnEvent"](event)
end

function CraftList2:ScanCraft(craftname)
	if not self.db.realm.data[UnitName("player")] then self.db.realm.data[UnitName("player")] = {} end
	if not self.db.realm.data[UnitName("player")][craftname] then self.db.realm.data[UnitName("player")][craftname] = {} end
	local craftdata = {}
	for i=1,GetNumCrafts() do
		local skillname, craftSubSpellName, skilltype = GetCraftInfo(i)
		if skilltype~="header" and skillname then
			local craftinfo = {}
			local link = GetCraftItemLink(i)
			local desc = GetCraftDescription(i)
			if desc == nil then desc = "" end
			craftinfo["name"]=skillname
			craftinfo["link"] = link
			craftinfo["desc"] = desc
			for k,v in pairs(self.db.realm.data[UnitName("player")][craftname]) do
				if v.name==skillname then 
					if v.ignored then craftinfo.ignored=true else craftinfo.ignored=false end
				end
			end
			table.insert(craftdata,craftinfo)
		end	
	end
	self.db.realm.data[UnitName("player")][craftname] = craftdata
end

function CraftList2:ScanTS(tsname)
	if not self.db.realm.data[UnitName("player")] then self.db.realm.data[UnitName("player")] = {} end
	if not self.db.realm.data[UnitName("player")][tsname] then self.db.realm.data[UnitName("player")][tsname] = {} end
	local tsdata = {}
	for i=1,GetNumTradeSkills() do
		local skillname, skilltype, numAvailable, isExpanded = GetTradeSkillInfo(i)
		if skilltype ~= "header" then
			local tsinfo = {}
			local itemlink = GetTradeSkillItemLink(i)
			local recipelink = GetTradeSkillRecipeLink(i)
			local reg = {}
			for j=1,GetTradeSkillNumReagents(i) do
				table.insert(reg,GetTradeSkillReagentItemLink(i,j))
			end
			tsinfo["name"]=skillname
			tsinfo["itemlink"] = itemlink
			tsinfo["recipelink"] = recipelink
			tsinfo["reg"] = reg
			for k,v in pairs(self.db.realm.data[UnitName("player")][tsname]) do
				if v.name==skillname then 
					if v.ignored then tsinfo.ignored=true else tsinfo.ignored=false end
				end
			end
			table.insert(tsdata,tsinfo)
		end	
	end
	self.db.realm.data[UnitName("player")][tsname] = tsdata
end


function CraftList2:CHAT_MSG_WHISPER()
	local argum = self:GetArgs(arg1," ")
	local sender = arg2
	local firstword = argum[1]
	table.remove(argum,1)
	argum=self:RecomposeLink(argum)
		
	if firstword == prefix_ench and self.db.realm.trigger_ench then 
		if argum[1] and argum[1]=="next" then
			if mem_search[sender]==nil then return end
			mem_next[sender]=mem_next[sender]+self.db.realm.maxresults
			argum=mem_search[sender]
		else
			mem_search[sender]=argum
			mem_next[sender]=0
		end
	
		if arg6==L["AFK"] or arg6==L["DND"] then self.filterafkdnd[sender] = true end
		self:ScheduleEvent(function() self.filterafkdnd[sender] = false return end, 1)
		self:HandleEnchant(argum,sender)
		
	elseif firstword == prefix_gem and self.db.realm.trigger_gem then 
		if argum[1] and argum[1]=="next" then
			if mem_search[sender]==nil then return end
			mem_next[sender]=mem_next[sender]+self.db.realm.maxresults
			argum=mem_search[sender]
		else
			mem_search[sender]=argum
			mem_next[sender]=0
		end
		
		if arg6==L["AFK"] or arg6==L["DND"] then self.filterafkdnd[sender] = true end
		self:ScheduleEvent(function() self.filterafkdnd[sender] = false return end, 1)
		self:HandleGem(argum,sender)
		
	elseif firstword == prefix_other and self.db.realm.trigger_other then 
		if argum[1] and argum[1]=="next" then
			if mem_search[sender]==nil then return end
			mem_next[sender]=mem_next[sender]+self.db.realm.maxresults
			argum=mem_search[sender]
		else
			mem_search[sender]=argum
			mem_next[sender]=0
		end
		if arg6==L["AFK"] or arg6==L["DND"] then self.filterafkdnd[sender] = true end
		self:ScheduleEvent(function() self.filterafkdnd[sender] = false return end, 1)
		self:HandleCraft(argum,sender)
		
	else return
	end
end

function CraftList2:WhisperHandler(event)
	if arg1 and arg1~="" then
		if (string.sub(arg1,1,string.len(prefix_ench))==prefix_ench and not self.db.realm.showrequests and self.db.realm.trigger_ench and event=="CHAT_MSG_WHISPER") then return end
		if (string.sub(arg1,1,string.len(prefix_gem))==prefix_gem and not self.db.realm.showrequests and self.db.realm.trigger_gem and event=="CHAT_MSG_WHISPER") then return end
		if (string.sub(arg1,1,string.len(prefix_other))==prefix_other and not self.db.realm.showrequests and self.db.realm.trigger_other and event=="CHAT_MSG_WHISPER") then return end
		if (string.sub(arg1,1,string.len(prefix_answers))==prefix_answers and not self.db.realm.showanswers and event=="CHAT_MSG_WHISPER_INFORM") then return end
	end
	return self.hooks["ChatFrame_MessageEventHandler"](event)
end

function CraftList2:GetArgs(text, separator)
	local args = {}
	local i = 0
	for value in string.gmatch(text, "[^"..separator.."]+") do
		i = i + 1
		args[i] = value
	end	
	return args
end

function CraftList2:RecomposeLink(argument)
	local message=argument
	for k,v in pairs(message) do
		if strfind(v,"|cff") then
				if strfind(v,"|h|r") then return message
				else 
					message[k]=v.." "..message[k+1]
					table.remove(message,k+1)
					return self:RecomposeLink(message)
				end
		end
	end
	return message
end

function CraftList2:Respond(message,sender)
	ChatThrottleLib:SendChatMessage("NORMAL", prefix_answers, prefix_answers.." "..message, "WHISPER", nil, sender)
end


function CraftList2:HandleEnchant(argum,sender)
	if #argum == 0 then 
		self:Respond(L["Usage: !enchant <any combination of keywords and itemlinks>"],sender) 
		self:Respond(L["Usage: example: !enchant [Ashbringer] 35 heal"],sender)
		return 
	end

	-- replace an itemlink with the piece of armor 
	for k,v in pairs(argum) do
		if strfind(argum[k],"|cff") and strfind(argum[k],"|h|r") then
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(argum[k])
			if sType == L["Armor"] then 
				local b=0
				if iel=="INVTYPE_CHEST" then b=L["Chest"]
				elseif iel=="INVTYPE_ROBE" then b=L["Chest"]
				elseif iel=="INVTYPE_FEET" then b=L["Boots"]
				elseif iel=="INVTYPE_WRIST" then b=L["Bracer"]
				elseif iel=="INVTYPE_HAND" then b=L["Gloves"]
				elseif iel=="INVTYPE_CLOAK" then b=L["Cloak"]
				elseif iel=="INVTYPE_SHIELD" then b=L["Shield"]
				elseif iel=="INVTYPE_FINGER" then b=L["Ring"]
				else self:Respond(L["Error! Cannot enchant that."],sender) return end
				argum[k]=b
			elseif sType==L["Weapon"] then 
				local b=0
				if iel=="INVTYPE_2HWEAPON" then b=L["Weapon"]
				elseif iel=="INVTYPE_WEAPONMAINHAND" then b=L["Enchant Weapon"]
				elseif iel=="INVTYPE_WEAPONOFFHAND" then b=L["Enchant Weapon"]
				elseif iel=="INVTYPE_WEAPON" then b=L["Enchant Weapon"]
				else self:Respond(L["Error! Cannot enchant that."],sender) return end
				argum[k]=b
			end
		end
	end
	-- done replacing
	
	-- building the results
	local searchresult={}
	if self.db.realm.data=={} then self:Respond(L["Database is currently empty."],sender) return end
	
	for character, tradeskill in pairs(self.db.realm.data) do
		if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
		if tradeskill[BTS["Enchanting"]] and not self.db.realm.ignored_crafts[character][BTS["Enchanting"]] then
			for nb,info in pairs(tradeskill[BTS["Enchanting"]]) do
				local match=0
				local enchantname=string.lower(info["name"])
				local enchantdesc=string.lower(info["desc"])
				for j=1,#argum do
					if strfind(enchantname, string.lower(argum[j])) then match=match+1 
					elseif strfind(enchantdesc, string.lower(argum[j])) then match=match+1
					end
				end 
				if match==#argum and not info["ignored"] then table.insert(searchresult,info["link"]) end	
			end	
		end
	end
	self:SendResults(searchresult,sender)
end

function CraftList2:HandleGem(argum,sender)
	if #argum == 0 then 
		self:Respond(L["Usage: !gem <any combination of color/stat/reagent/text>"],sender) 
		self:Respond(L["Usage: example: !gem red, !gem [Talasite], !gem 5 strength"],sender)
		return 
	end
	
	local searchresult={}
	if self.db.realm.data=={} then self:Respond(L["Database is currently empty."],sender) return end
	
	
	for k,v in pairs(argum) do
		if strfind(argum[k],"|cff") and strfind(argum[k],"|h|r") then
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(argum[k])
			argum[k] = sName
		end
	end


	for character, tradeskill in pairs(self.db.realm.data) do
		if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
		if tradeskill[BTS["Jewelcrafting"]] and not self.db.realm.ignored_crafts[character][BTS["Jewelcrafting"]] then
			for nb,info in pairs(tradeskill[BTS["Jewelcrafting"]]) do
				local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(info["itemlink"])
				if sType== L["Gem"] then
					local match=0
					local gemname=string.lower(info["name"])
					G:SetHyperlink(info["itemlink"])
					local gemdesc=string.lower(G:GetLine(2))
					local gemcolor=string.lower(G:GetLine(G:NumLines()) )
					local reg = info["reg"]
					for j=1,#argum do
						if strfind(gemname, string.lower(argum[j])) then match=match+1 
						elseif strfind(gemdesc, string.lower(argum[j])) then match=match+1
						elseif strfind(gemcolor,string.lower(argum[j])) then match = match+1
						else 
							for k,v in pairs(reg) do
								if strfind(v,argum[j]) then match = match+1 end
							end
						end
					end 
					if match==#argum and not info["ignored"] then table.insert(searchresult,info["itemlink"]) end	
				end
			end	
		end
	end

	self:SendResults(searchresult,sender)
end

function CraftList2:HandleCraft(argum,sender)
	if #argum == 0 then 
		self:Respond(L["Usage: !craft <any combination of reagent/text>"],sender) 
		self:Respond(L["Usage: example: !craft belt of blasting, !craft belt [Primal Fire]"], sender)
		return 
	end
	
	local searchresult={}
	if self.db.realm.data=={} then self:Respond(L["Database is currently empty."],sender) return end
	
	
	for k,v in pairs(argum) do
		if strfind(argum[k],"|cff") and strfind(argum[k],"|h|r") then
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(argum[k])
			argum[k] = sName
		end
	end


	for character, tradeskill in pairs(self.db.realm.data) do
		for ts,tsinfo in pairs(tradeskill) do
			if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
			if not self.db.realm.ignored_crafts[character][ts] then
				for nb,info in pairs(tsinfo) do
					local match=0
					local craftname=string.lower(info["name"])
					local reg = info["reg"]
					for j=1,#argum do
						if strfind(craftname, string.lower(argum[j])) then match=match+1 
						else 
							if reg then
								for k,v in pairs(reg) do
									if strfind(v,argum[j]) then match = match+1 end
								end
							end
						end
					end 
					if match==#argum and not info["ignored"] then 
						if info["recipelink"] then table.insert(searchresult,info["recipelink"]) 
						else table.insert(searchresult,info["link"]) 
						end
					end	
				end
			end
		end
	end

	self:SendResults(searchresult,sender)
end

function CraftList2:SendResults(searchresult,sender)
	if #searchresult == 0 then self:Respond(L["Nothing found."],sender) return end
	
	if mem_next[sender] and mem_next[sender] > 0 then 
		for i=1,mem_next[sender] do
			table.remove(searchresult,1)
		end
	end
	
	local max = self.db.realm.maxresults
	local endstring
	if #searchresult < max  or max == 0 then 
		max = #searchresult 
		endstring=(L["%d result(s)."]):format(#searchresult)
	else
		endstring=L["Maximum results exceeded, be more specific or use '!trigger next' to get next results."]
	end

	for i=1,max do
		self:Respond(searchresult[i],sender)
	end
	self:Respond(endstring,sender)
end
